import { ref as x, reactive as te, computed as ge, toRefs as Be, defineComponent as he, onMounted as De, resolveComponent as m, openBlock as c, createBlock as v, withCtx as o, createElementVNode as G, renderSlot as R, createVNode as i, unref as e, createElementBlock as U, Fragment as K, renderList as W, mergeProps as B, withModifiers as Ce, createTextVNode as q, toDisplayString as ne, createCommentVNode as z, resolveDirective as Ve, withDirectives as de, createSlots as ke, resolveDynamicComponent as Le, normalizeProps as Ne, guardReactiveProps as ze, withKeys as Ke, vShow as qe, isRef as Ie } from "vue";
import { ElMessage as Oe, ElMessageBox as Se, ElNotification as je, ElButton as oe, ElButtonGroup as We, ElDialog as Qe } from "element-plus";
import { useRoute as Je } from "vue-router";
const T = x({
  debug: !1,
  mainMaxHeight: 700,
  isAfterMountQuery: !1,
  isOpenSearchForm: !1,
  Form_LabelWidth: 120,
  Dialog_Width: 800,
  Dialog_isFullscreen: !1,
  Dialog_isCloseOnPressEscape: !0,
  Dialog_isCloseOnClickModal: !1,
  Dialog_isFooterButton: !0,
  Table_isOpenIndex: !0,
  Table_isOpenMultipleSelection: !1,
  Table_isOpenExpand: !0,
  Table_ExpandColumn: 4,
  Table_MenuWidth: 200,
  Table_MenuAlign: "left",
  Page_PageSizes: [10, 20, 50, 100],
  Page_PageParams: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  Page_Layout: "->,total, sizes, prev, pager, next, jumper",
  Page_isHideOnSinglePage: !1,
  ApiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
}), d = x({
  CompRef: {},
  Mode: "add",
  DialogVisible: !1,
  tableLoading: !1,
  submitLoading: !1,
  DialogVisibleFooterButton: !0,
  ElementArrs: { filter: {}, editor: {}, column: {}, columns: {} },
  tableColumn: [],
  originalData: [],
  tableData: [],
  multipleSelection: [],
  uploadFiles: [],
  initSearchModel: {},
  initEditModel: {},
  searchFormValue: {},
  searchModel: {},
  editFormValue: {},
  editModel: {}
}), _e = x({});
function I(n) {
  let p;
  try {
    p = Array.isArray(n) ? [] : {}, n === null && (p = null);
  } catch {
    p = {};
  }
  for (const f in n)
    typeof n[f] == "object" ? p[f] = I(n[f]) : p[f] = n[f];
  return p;
}
function Pe(...n) {
  function p(a) {
    return typeof a == "object" && Object.prototype.toString.call(a) === "[object Object]";
  }
  let f = arguments.length, _ = arguments[0];
  p(_) || (_ = {});
  for (let a = 1; a < f; a++) {
    let h = arguments[a];
    if (p(h))
      for (let C in h)
        C === "__proto__" || _ === h[C] || _.hasOwnProperty(C) && (p(h[C]) ? _[C] = Pe(_[C], h[C]) : _[C] = h[C]);
  }
  return _;
}
function Ge(n, p) {
  let f = {}, _ = Object.getOwnPropertyNames(n), a = Object.getOwnPropertyNames(p);
  return _.length === a.length && _.forEach((h) => {
    n[h] !== p[h] && (f[h] = p[h]);
  }), f;
}
const ae = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeBatchDeteleHandler: "beforeBatchDeteleHandler",
  afterBatchDeteleHandler: "afterBatchDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Xe(n = { debug: !1 }) {
  const p = te({
    hooks: {}
  });
  return Object.keys(n).forEach((_) => {
    _ !== "debug" && (p.hooks[_] = n[_]);
  }), {
    hookHandler: (_, a) => {
      let h = !1;
      try {
        n.debug && (console.group("DeBug\uFF1A", _), console.table(a.Data), console.groupEnd()), h = p.hooks[_](a);
      } catch {
        h = !0;
      }
      return h;
    }
  };
}
let w = {}, Te = {};
const se = x(), Ye = (n) => {
  se.value = n.CrudRequest, T.value = Pe(T.value, n), ve("\u3010\u521D\u59CB\u5316Options\u3011", n), w = { ...T.value }, Te = { ...d.value };
}, Ze = (n) => {
  _e.value = I(n), T.value = I(w), d.value = I(Te), el(_e.value.source), T.value = Pe(T.value, _e.value), ve("UseCrudStates\u4F20\u53C2\u3010props\u3011", _e.value), ve("\u3010DefParams\u3011", T.value), ve("\u3010CrudStates\u3011", d.value);
};
function Fe() {
  return { ...Be(T.value) };
}
function k() {
  return { ...Be(d.value) };
}
function xe() {
  return { ...Be(_e.value) };
}
const Ae = () => {
  const n = _e.value, p = (t) => {
    let r = {};
    return n.rowKey && (r[n.rowKey] = t[n.rowKey]), n.rowKeys && n.rowKeys.forEach((y) => {
      r[y] = t[y];
    }), r;
  }, { hookHandler: f } = Xe(n.hooks);
  function _() {
    d.value.tableLoading = !0;
    const t = te({ ...d.value.initSearchModel, ...d.value.searchModel });
    for (const r in t)
      typeof t[r] == "string" && (t[r] = t[r].trim(), t[r] === "" && (t[r] = void 0)), t[r] === null && (t[r] = void 0);
    !f(ae.beforeQueryHandler, { CrudState: d.value, Data: t }) || se.value({
      url: n.url,
      name: T.value.ApiName.query,
      data: {
        pagenum: T.value.Page_PageParams.current,
        pagesize: T.value.Page_PageParams.pageSize,
        ...t
      }
    }).then((r) => {
      const { data: y, page: V } = r;
      setTimeout(() => {
        a(y, t), T.value.Page_PageParams.total = V.total, d.value.tableLoading = !1;
      }, 50);
    }).catch(() => {
      d.value.tableLoading = !1;
    });
  }
  const a = (t, r) => {
    Object.keys(r).filter((V) => r[V] != null).length == 0 && (d.value.originalData = t), d.value.originalData = I(t), f(ae.afterQueryHandler, { CrudState: d.value, Data: t }) && (d.value.tableData = I(t));
  };
  function h() {
    d.value.editModel = I(d.value.initEditModel);
    const t = te({ ...d.value.editModel });
    !f(ae.beforeAddHandler, { CrudState: d.value, Data: t }) || (d.value.Mode = "add", d.value.DialogVisible = !0);
  }
  const C = (t) => {
    const r = te({
      ...t
    });
    if (!f(ae.beforeEditHandler, { CrudState: d.value, Data: r }))
      return;
    const y = I(r);
    Object.keys(y).forEach((V) => {
      d.value.editModel[V] = y[V], d.value.editFormValue[V] = y[V];
    }), d.value.Mode = "edit", d.value.DialogVisible = !0;
  }, P = async (t) => {
    !t || await t.validate((r) => {
      if (r) {
        const y = te({
          ...d.value.editModel
        });
        if (!f(ae.beforeSubmitHandler, { CrudState: d.value, Data: y }))
          return;
        d.value.Mode === "add" ? F(y) : S(y);
      }
    });
  }, F = (t) => {
    d.value.submitLoading = !0;
    let r = t;
    t.FormData instanceof FormData && (r = t.FormData), se.value({ url: n.url, name: T.value.ApiName.add, data: r }).then(() => {
      d.value.DialogVisible = !1, be("\u65B0\u589E\u6210\u529F"), _(), d.value.submitLoading = !1;
    }).catch(() => {
      d.value.submitLoading = !1;
    });
  }, S = (t) => {
    d.value.submitLoading = !1;
    let r = t;
    if (t.FormData instanceof FormData)
      r = t.FormData;
    else {
      const y = Ge(d.value.editModel, r);
      if (JSON.stringify(y) === "{}")
        return d.value.submitLoading = !1, Oe({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
      r = {
        ...p(t),
        ...y
      };
    }
    se.value({ url: n.url, name: T.value.ApiName.edit, data: r }).then(() => {
      d.value.DialogVisible = !1, be("\u7F16\u8F91\u6210\u529F"), _(), d.value.submitLoading = !1;
    }).catch(() => {
      d.value.submitLoading = !1;
    });
  };
  return {
    queryRecord: _,
    addRecord: h,
    editRecord: C,
    handleSubmit: P,
    delFlag: (t) => {
      Se.confirm(`\u786E\u5B9A\u8981 \u201C${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          ...p(t),
          deleteFlag: t.deleteFlag == 0 ? 1 : 0
        });
        !f(ae.beforedisabledHandler, { CrudState: d.value, Data: r }) || se.value({
          url: n.url,
          name: T.value.ApiName.deleteFlag,
          data: r
        }).then(() => {
          be(`\u6570\u636E${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), _();
        });
      }).catch(() => {
      });
    },
    deleteRecord: (t) => {
      Se.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          ...p(t)
        });
        !f(ae.beforeDeteleHandler, { CrudState: d.value, Data: r }) || se.value({
          url: n.url,
          name: T.value.ApiName.delete,
          data: r
        }).then(() => {
          be("\u5220\u9664\u6210\u529F"), _();
        });
      }).catch(() => {
      });
    },
    deleteMulRecord: () => {
      const t = d.value.multipleSelection.map((r) => r[n.rowKey]);
      Se.confirm(`\u786E\u5B9A\u8981\u5220\u9664\u8FD9 ${t.length} \u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          [n.rowKey]: t,
          selection: d.value.multipleSelection
        });
        !f(ae.beforeBatchDeteleHandler, { CrudState: d.value, Data: r }) || se.value({
          url: n.url,
          name: T.value.ApiName.remove,
          data: r
        }).then(() => {
          be("\u6279\u91CF\u5220\u9664\u6210\u529F"), d.value.multipleSelection = [], d.value.CompRef.TableRef.clearSelection(), _();
        });
      }).catch(() => {
      });
    }
  };
};
function ve(...n) {
  T.value.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...n);
}
const el = (n) => {
  const { filter: p, editor: f, column: _, columns: a } = n;
  d.value.ElementArrs = { filter: {}, editor: {}, column: {}, columns: {} };
  let h = {};
  p.forEach((P) => {
    try {
      h[P] = a[P].searchDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", P);
    }
    d.value.ElementArrs.filter[P] = a[P];
  }), d.value.initSearchModel = I(h), d.value.searchModel = I(d.value.initSearchModel);
  let C = {};
  f.forEach((P) => {
    try {
      C[P] = a[P].addDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", P);
    }
    d.value.ElementArrs.editor[P] = a[P];
  }), d.value.initEditModel = I(C), _.forEach((P) => {
    d.value.ElementArrs.column[P] = a[P];
  }), d.value.ElementArrs.columns = a;
};
ge(() => {
  let n = [];
  for (const p in d.value.ElementArrs.editor)
    Object.prototype.hasOwnProperty.call(d.value.ElementArrs.editor, p) && d.value.ElementArrs.editor[p].type === "el-upload" && n.push(p);
  return n;
});
const be = (n, p = "success") => {
  je({
    title: n,
    type: p,
    offset: 70,
    duration: 2500
  });
}, ll = /* @__PURE__ */ he({
  __name: "crud_SearchForm",
  setup(n) {
    const p = x(), { Form_LabelWidth: f } = Fe(), {
      CompRef: _,
      searchModel: a,
      ElementArrs: {
        value: { filter: h }
      }
    } = k();
    De(() => {
      _.value.SearchFormRef = p.value;
    });
    const C = (F) => {
      var S, E;
      return F.range ? (S = F.formProps) != null && S.type ? F.formProps.type + "range" : "daterange" : (E = F.formProps) != null && E.type ? F.formProps.type : "date";
    }, P = (F, S, E) => {
      a.value[S] === E ? a.value[S] = void 0 : a.value[S] = F.formProps.options[E].value;
    };
    return (F, S) => {
      const E = m("el-input"), M = m("el-form-item"), $ = m("el-col"), t = m("el-input-number"), r = m("el-option"), y = m("el-select"), V = m("el-date-picker"), L = m("el-time-picker"), X = m("el-radio"), Y = m("el-radio-button"), re = m("el-radio-group"), j = m("el-row"), Z = m("el-form"), ee = m("el-collapse-transition");
      return c(), v(ee, null, {
        default: o(() => [
          G("div", null, [
            R(F.$slots, "search-form", {}, void 0, !0),
            i(Z, {
              ref_key: "SearchFormRef",
              ref: p,
              model: e(a),
              "label-width": e(f)
            }, {
              default: o(() => [
                i(j, null, {
                  default: o(() => [
                    R(F.$slots, "search-form-top", {}, void 0, !0),
                    (c(!0), U(K, null, W(e(h), (u, D) => {
                      var Q;
                      return c(), U(K, null, [
                        u.type === "el-input" ? (c(), v($, {
                          key: 0,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            i(M, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                i(E, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  clearable: "",
                                  placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-input-number" ? (c(), v($, {
                          key: 1,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            i(M, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                i(t, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-select" ? (c(), v($, {
                          key: 2,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            i(M, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                i(y, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9"
                                }, u.formProps), {
                                  default: o(() => [
                                    (c(!0), U(K, null, W(u.formProps.options, (g) => (c(), v(r, {
                                      key: g.value,
                                      label: g.label,
                                      value: g.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" && !C(u).includes("range") ? (c(), v($, {
                          key: 3,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            i(M, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                i(V, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  "range-separator": "\u81F3",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" ? (c(), v($, {
                          key: 4,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            i(M, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                i(V, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, {
                                  type: C(u)
                                }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" && !((Q = u.formProps) != null && Q.isRange) && !u.range ? (c(), v($, {
                          key: 5,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            i(M, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                i(L, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" ? (c(), v($, {
                          key: 6,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            i(M, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                i(L, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, { "is-range": "" }), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-radio-group" ? (c(), v($, {
                          key: 7,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            i(M, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                i(re, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g
                                }, u.formProps), {
                                  default: o(() => [
                                    u.formProps.button ? z("", !0) : (c(!0), U(K, { key: 0 }, W(u.formProps.options, (g) => (c(), v(X, B({
                                      key: g.value,
                                      label: g.value,
                                      onClick: Ce((le) => P(u, D, g.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(ne(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    u.formProps.button ? (c(!0), U(K, { key: 1 }, W(u.formProps.options, (g) => (c(), v(Y, B({
                                      key: g.value,
                                      label: g.value,
                                      onClick: Ce((le) => P(u, D, g.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(ne(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64);
                    }), 256)),
                    R(F.$slots, "search-form-bottom", {}, void 0, !0)
                  ]),
                  _: 3
                })
              ]),
              _: 3
            }, 8, ["model", "label-width"])
          ])
        ]),
        _: 3
      });
    };
  }
});
const Re = (n, p) => {
  const f = n.__vccOpts || n;
  for (const [_, a] of p)
    f[_] = a;
  return f;
}, ol = /* @__PURE__ */ Re(ll, [["__scopeId", "data-v-394e11ba"]]), al = { class: "edit" }, tl = { class: "edit_form" }, nl = /* @__PURE__ */ he({
  __name: "crud_EditForm",
  props: {
    height: Number
  },
  setup(n) {
    const p = x(), { Form_LabelWidth: f } = Fe(), {
      CompRef: _,
      editModel: a,
      Mode: h,
      ElementArrs: {
        value: { editor: C }
      },
      uploadFiles: P
    } = k();
    De(() => {
      _.value.EditFormRef = p.value;
    });
    const F = ge(() => {
      let t = {};
      return xe().source.value.editor.forEach((r) => {
        typeof C[r].visible == "function" ? C[r].visible(k(), h.value) && (t[r] = C[r]) : t[r] = C[r];
      }), t;
    }), S = ({ showFileList: t }) => {
      if (t)
        return !1;
      if (P.value[0])
        return URL.createObjectURL(P.value[0]);
    }, E = (t) => typeof t.disabled == "function" ? t.disabled(k(), h.value) : !1, M = (t) => {
      let r = { ...t };
      return Object.keys(r).forEach((y) => {
        typeof r[y] == "function" && (r[y] = r[y].bind(this, k()));
      }), r;
    }, $ = (t, r, y) => {
      a.value[r] === y ? a.value[r] = void 0 : a.value[r] = t.formProps.options[y].value;
    };
    return (t, r) => {
      const y = m("el-input"), V = m("el-form-item"), L = m("el-col"), X = m("el-input-number"), Y = m("el-option"), re = m("el-select"), j = m("el-date-picker"), Z = m("el-time-picker"), ee = m("el-cascader"), u = m("el-button"), D = m("el-image"), Q = m("plus"), g = m("el-icon"), le = m("el-upload"), ie = m("el-radio"), ce = m("el-radio-button"), pe = m("el-radio-group"), me = m("el-row"), A = m("el-form"), O = m("el-scrollbar");
      return c(), U("div", al, [
        i(O, {
          height: n.height,
          "max-height": n.height
        }, {
          default: o(() => [
            G("div", tl, [
              R(t.$slots, "edit-form", { editModel: e(a) }, void 0, !0),
              i(A, {
                ref_key: "EditFormRef",
                ref: p,
                model: e(a),
                "label-width": e(f)
              }, {
                default: o(() => [
                  i(me, null, {
                    default: o(() => [
                      R(t.$slots, "edit-form-top", { editModel: e(a) }, void 0, !0),
                      (c(!0), U(K, null, W(e(F), (l, s) => (c(), U(K, { key: s }, [
                        l.type === "el-input" ? (c(), v(L, {
                          key: 0,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            i(V, {
                              label: l.label,
                              prop: s,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                i(y, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[s],
                                  "onUpdate:modelValue": (b) => e(a)[s] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: E(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-input-number" ? (c(), v(L, {
                          key: 1,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            i(V, {
                              label: l.label,
                              prop: s,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                i(X, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[s],
                                  "onUpdate:modelValue": (b) => e(a)[s] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: E(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-select" ? (c(), v(L, {
                          key: 2,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            i(V, {
                              label: l.label,
                              prop: s,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                i(re, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[s],
                                  "onUpdate:modelValue": (b) => e(a)[s] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: E(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    (c(!0), U(K, null, W(l.formProps.options, (b) => (c(), v(Y, {
                                      key: b.value,
                                      label: b.label,
                                      value: b.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-date-picker" ? (c(), v(L, {
                          key: 3,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            i(V, {
                              label: l.label,
                              prop: s,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                i(j, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[s],
                                  "onUpdate:modelValue": (b) => e(a)[s] = b,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: E(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-time-picker" ? (c(), v(L, {
                          key: 4,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            i(V, {
                              label: l.label,
                              prop: s,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                i(Z, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[s],
                                  "onUpdate:modelValue": (b) => e(a)[s] = b,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: E(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-cascader" ? (c(), v(L, {
                          key: 5,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            i(V, {
                              label: l.label,
                              prop: s,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                i(ee, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[s],
                                  "onUpdate:modelValue": (b) => e(a)[s] = b,
                                  props: l.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: E(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-upload" ? (c(), v(L, {
                          key: 6,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            i(V, {
                              label: l.label,
                              prop: s,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                i(le, B({
                                  style: { width: "100%" },
                                  ref_for: !0,
                                  ref: s + "UploadRef",
                                  action: ""
                                }, M(l.formProps)), {
                                  default: o(() => {
                                    var b;
                                    return [
                                      ((b = l.formProps) == null ? void 0 : b.listType) !== "picture-card" ? (c(), v(u, {
                                        key: 0,
                                        type: "primary"
                                      }, {
                                        default: o(() => [
                                          q(ne(l.formProps.butName || "\u70B9\u51FB\u4E0A\u4F20\u6587\u4EF6"), 1)
                                        ]),
                                        _: 2
                                      }, 1024)) : z("", !0),
                                      l.formProps.listType === "picture-card" && S(l.formProps) ? (c(), v(D, {
                                        key: 1,
                                        style: { width: "146px", height: "146px", "border-radius": "5px" },
                                        fit: "contain",
                                        src: S(l.formProps)
                                      }, null, 8, ["src"])) : z("", !0),
                                      l.formProps.listType == "picture-card" && !S(l.formProps) ? (c(), v(g, { key: 2 }, {
                                        default: o(() => [
                                          i(Q)
                                        ]),
                                        _: 1
                                      })) : z("", !0)
                                    ];
                                  }),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-radio-group" ? (c(), v(L, {
                          key: 7,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            i(V, {
                              label: l.label,
                              prop: s,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                i(pe, B({
                                  modelValue: e(a)[s],
                                  "onUpdate:modelValue": (b) => e(a)[s] = b,
                                  disabled: E(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    l.formProps.button ? z("", !0) : (c(!0), U(K, { key: 0 }, W(l.formProps.options, (b) => (c(), v(ie, B({
                                      key: b.value,
                                      label: b.value,
                                      onClick: Ce((fe) => $(l, s, b.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(ne(b.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    l.formProps.button ? (c(!0), U(K, { key: 1 }, W(l.formProps.options, (b) => (c(), v(ce, B({
                                      key: b.value,
                                      label: b.value,
                                      onClick: Ce((fe) => $(l, s, b.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(ne(b.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64))), 128)),
                      R(t.$slots, "edit-form-bottom", { editModel: e(a) }, void 0, !0)
                    ]),
                    _: 3
                  })
                ]),
                _: 3
              }, 8, ["model", "label-width"])
            ])
          ]),
          _: 3
        }, 8, ["height", "max-height"])
      ]);
    };
  }
});
const rl = /* @__PURE__ */ Re(nl, [["__scopeId", "data-v-08532dff"]]), ul = { key: 1 }, sl = /* @__PURE__ */ he({
  __name: "crud_Table",
  props: { height: Number },
  emits: ["row-contextmenu"],
  setup(n, { emit: p }) {
    const f = x(), { Table_isOpenMultipleSelection: _, Table_isOpenIndex: a, Table_isOpenExpand: h, Table_ExpandColumn: C, Table_MenuAlign: P, Table_MenuWidth: F, Page_PageParams: S, Permission: E, Permissions: M } = Fe(), {
      CompRef: $,
      tableData: t,
      tableLoading: r,
      ElementArrs: {
        value: { filter: y, column: V, columns: L }
      },
      searchModel: X,
      multipleSelection: Y
    } = k(), { rowKey: re, keyName: j, Table_Attributes: Z } = xe(), { queryRecord: ee, editRecord: u, delFlag: D, deleteRecord: Q } = Ae();
    De(() => {
      $.value.TableRef = f.value;
    });
    const g = ge(() => {
      var A, O;
      return (((A = S == null ? void 0 : S.value) == null ? void 0 : A.current) - 1) * ((O = S == null ? void 0 : S.value) == null ? void 0 : O.pageSize) + 1;
    }), le = (A) => {
      Y.value = A;
    }, ie = (A, O, l, s) => {
      O.label && navigator.clipboard.writeText(l.innerText).then(() => {
        Oe.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, ce = (A, O, l) => {
      l.preventDefault(), p("row-contextmenu", { row: A, column: O, event: l }, k());
    }, pe = (A, O, l) => {
      if (O.formProps) {
        const s = O.formProps.options.findIndex((b) => b.value == A[l]);
        return s === -1 ? A[l] : O.formProps.options[s].label;
      } else
        return A[l];
    }, me = (A, O) => {
      let l = { ...A };
      return Object.keys(l).forEach((s) => {
        typeof l[s] == "function" && (l[s] = l[s].call(this, k(), O));
      }), l;
    };
    return (A, O) => {
      const l = m("el-empty"), s = m("el-table-column"), b = m("el-descriptions-item"), fe = m("el-descriptions"), ye = m("el-input"), N = m("el-button"), $e = m("el-table"), Ee = Ve("Auth"), Ue = Ve("loading");
      return de((c(), v($e, B({
        ref_key: "TableRef",
        ref: f,
        data: e(t),
        "row-key": e(re),
        height: n.height,
        onCellDblclick: ie,
        onSelectionChange: le,
        onRowContextmenu: ce
      }, e(Z)), {
        empty: o(() => [
          i(l, {
            "image-size": 80,
            description: "\u6682\u65E0\u6570\u636E"
          })
        ]),
        default: o(() => [
          e(_) ? (c(), v(s, {
            key: 0,
            type: "selection",
            "reserve-selection": "",
            width: 44
          })) : z("", !0),
          e(h) ? (c(), v(s, {
            key: 1,
            type: "expand",
            width: 55
          }, {
            default: o((H) => [
              i(fe, {
                column: e(C),
                border: ""
              }, {
                default: o(() => [
                  (c(!0), U(K, null, W(e(L), (J, ue) => (c(), U(K, { key: ue }, [
                    J.hidden ? z("", !0) : (c(), v(b, {
                      key: 0,
                      label: J.label
                    }, {
                      default: o(() => [
                        q(ne(pe(H.row, J, ue)), 1)
                      ]),
                      _: 2
                    }, 1032, ["label"]))
                  ], 64))), 128))
                ]),
                _: 2
              }, 1032, ["column"])
            ]),
            _: 1
          })) : z("", !0),
          e(a) ? (c(), v(s, {
            key: 2,
            label: "###",
            width: 55,
            "show-overflow-tooltip": ""
          }, {
            default: o(({ $index: H }) => [
              q(ne(e(g) + H), 1)
            ]),
            _: 1
          })) : z("", !0),
          (c(!0), U(K, null, W(e(V), (H, J) => (c(), v(s, B({
            key: J,
            align: H.align || "left",
            label: H.label,
            prop: J
          }, H.tableProps, { "show-overflow-tooltip": "" }), ke({ _: 2 }, [
            H.columnSlot ? {
              name: "default",
              fn: o((ue) => [
                (c(), v(Le(H.columnSlot.is), Ne(ze(me(H.columnSlot, ue))), null, 16))
              ])
            } : void 0
          ]), 1040, ["align", "label", "prop"]))), 128)),
          R(A.$slots, "table-column"),
          i(s, {
            align: e(P) || "left",
            width: e(F)
          }, {
            header: o(() => [
              e(j) ? (c(), v(ye, {
                key: 0,
                modelValue: e(X)[e(j)],
                "onUpdate:modelValue": O[0] || (O[0] = (H) => e(X)[e(j)] = H),
                placeholder: e(y)[e(j)].label + "\u6A21\u7CCA\u67E5\u627E",
                clearable: "",
                onKeyup: Ke(e(ee), ["enter", "native"])
              }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : (c(), U("span", ul, "\u64CD\u4F5C"))
            ]),
            default: o((H) => {
              var J, ue, Me;
              return [
                R(A.$slots, "menu-top", { scope: H }),
                de((c(), v(N, {
                  plain: "",
                  type: H.row[e(E).deleteFlag] ? "danger" : "success",
                  onClick: (He) => e(D)(H.row)
                }, {
                  default: o(() => [
                    q(ne(H.row[e(E).deleteFlag] ? "\u7981\u7528" : "\u542F\u7528"), 1)
                  ]),
                  _: 2
                }, 1032, ["type", "onClick"])), [
                  [Ee, { Permissions: e(M), access: [(J = e(E)) == null ? void 0 : J.deleteFlag] }]
                ]),
                de(i(N, {
                  plain: "",
                  type: "primary",
                  icon: "edit",
                  onClick: (He) => e(u)(H.row)
                }, null, 8, ["onClick"]), [
                  [Ee, { Permissions: e(M), access: [(ue = e(E)) == null ? void 0 : ue.edit] }]
                ]),
                de(i(N, {
                  plain: "",
                  type: "danger",
                  icon: "delete",
                  onClick: (He) => e(Q)(H.row)
                }, null, 8, ["onClick"]), [
                  [Ee, { Permissions: e(M), access: [(Me = e(E)) == null ? void 0 : Me.delete] }]
                ]),
                R(A.$slots, "menu-bottom", { scope: H })
              ];
            }),
            _: 3
          }, 8, ["align", "width"])
        ]),
        _: 3
      }, 16, ["data", "row-key", "height"])), [
        [Ue, e(r)]
      ]);
    };
  }
}), dl = /* @__PURE__ */ he({
  __name: "crud_Pagination",
  setup(n) {
    const { Page_PageSizes: p, Page_PageParams: f, Page_Layout: _, Page_isHideOnSinglePage: a } = Fe(), { queryRecord: h } = Ae(), C = (F) => {
      f.value.pageSize = F, h();
    }, P = (F) => {
      f.value.current = F, f.value.current != null && h();
    };
    return (F, S) => {
      const E = m("el-pagination");
      return c(), v(E, {
        "hide-on-single-page": e(a),
        "current-page": e(f).current,
        "page-size": e(f).pageSize,
        "page-sizes": e(p),
        background: "",
        layout: e(_),
        total: e(f).total,
        onSizeChange: C,
        onCurrentChange: P
      }, null, 8, ["hide-on-single-page", "current-page", "page-size", "page-sizes", "layout", "total"]);
    };
  }
}), il = { style: { padding: "20px", "background-color": "#fff" } }, cl = { class: "button_left" }, pl = /* @__PURE__ */ q(" \u65B0\u589E "), fl = /* @__PURE__ */ q(" \u6279\u91CF\u5220\u9664 "), _l = { class: "button_right" }, ml = { style: { display: "flex", "justify-content": "flex-end" } }, bl = /* @__PURE__ */ q("\u53D6\u6D88"), vl = /* @__PURE__ */ q("\u91CD\u7F6E"), gl = /* @__PURE__ */ q("\u63D0\u4EA4"), hl = /* @__PURE__ */ he({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    debug: { type: Boolean, default: () => w.debug },
    mainMaxHeight: { default: () => w.mainMaxHeight },
    isAfterMountQuery: { type: Boolean, default: () => w.isAfterMountQuery },
    isOpenSearchForm: { type: Boolean, default: () => w.isOpenSearchForm },
    Form_LabelWidth: { default: () => w.Form_LabelWidth },
    Dialog_Width: { default: () => w.Dialog_Width },
    Dialog_isFullscreen: { type: Boolean, default: () => w.Dialog_isFullscreen },
    Dialog_isCloseOnPressEscape: { type: Boolean, default: () => w.Dialog_isCloseOnPressEscape },
    Dialog_isCloseOnClickModal: { type: Boolean, default: () => w.Dialog_isCloseOnClickModal },
    Dialog_isFooterButton: { type: Boolean, default: () => w.Dialog_isFooterButton },
    Table_Attributes: null,
    Table_isOpenIndex: { type: Boolean, default: () => w.Table_isOpenIndex },
    Table_isOpenMultipleSelection: { type: Boolean, default: () => w.Table_isOpenMultipleSelection },
    Table_isOpenExpand: { type: Boolean, default: () => w.Table_isOpenExpand },
    Table_ExpandColumn: { default: () => w.Table_ExpandColumn },
    Page_PageSizes: { default: () => w.Page_PageSizes },
    Page_PageParams: { default: () => w.Page_PageParams },
    Page_Layout: { default: () => w.Page_Layout },
    Page_isHideOnSinglePage: { type: Boolean, default: () => w.Page_isHideOnSinglePage },
    ApiName: { default: () => w.ApiName },
    Permission: { default: () => w.Permission },
    Permissions: { default: () => w.Permissions }
  },
  emits: ["row-contextmenu"],
  setup(n, { emit: p }) {
    const f = n, _ = Je();
    Ze(f);
    const { queryRecord: a, addRecord: h, handleSubmit: C, deleteMulRecord: P } = Ae(), { CompRef: F, initSearchModel: S, Mode: E, DialogVisible: M, multipleSelection: $, submitLoading: t, DialogVisibleFooterButton: r } = k(), { isOpenSearchForm: y, isAfterMountQuery: V, Table_isOpenMultipleSelection: L, Dialog_Width: X, Dialog_isFullscreen: Y, Dialog_isCloseOnPressEscape: re, Dialog_isCloseOnClickModal: j, Permission: Z, Permissions: ee } = Fe();
    if (_.params.data) {
      ve("\u8DEF\u7531\u4F20\u53C2\uFF1A", _.params.data);
      let l = _.params.data, s = JSON.parse(l);
      S.value = Pe(S.value, s);
    }
    const u = x(), D = x(), Q = x(), g = x(), le = x(0), ie = x(0), ce = x(0), pe = x(0);
    De(() => {
      F.value.containerDivRef = u.value, F.value.searchDivRef = D.value, F.value.buttonDivRef = Q.value, F.value.paginationDivRef = g.value, le.value = u.value.offsetHeight - 40, ie.value = F.value.searchDivRef.offsetHeight, ce.value = F.value.buttonDivRef.offsetHeight, pe.value = F.value.paginationDivRef.offsetHeight, V.value && a();
    });
    const me = ge(() => {
      const l = x(le.value - ce.value - pe.value);
      return y.value ? l.value - ie.value : l.value;
    }), A = ge(() => {
      const l = x(document.documentElement.clientHeight);
      return Y.value ? l.value - 54 - 62 - 2 : l.value - 54 - 62 - 2 - l.value * 0.15 - 50;
    }), O = ({ row: l, event: s }, b) => {
      p("row-contextmenu", { row: l, event: s }, b);
    };
    return (l, s) => {
      var fe, ye;
      const b = Ve("Auth");
      return c(), U("div", {
        ref_key: "containerDivRef",
        ref: u,
        style: { height: "100%" }
      }, [
        G("div", il, [
          G("div", {
            ref_key: "searchDivRef",
            ref: D
          }, [
            de(i(ol, null, {
              "search-form": o(() => [
                R(l.$slots, "search-form", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              "search-form-top": o(() => [
                R(l.$slots, "search-form-top", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              "search-form-bottom": o(() => [
                R(l.$slots, "search-form-bottom", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              _: 3
            }, 512), [
              [qe, e(y)]
            ])
          ], 512),
          G("div", {
            ref_key: "buttonDivRef",
            ref: Q,
            class: "buttonDiv"
          }, [
            G("div", cl, [
              de((c(), v(e(oe), {
                type: "primary",
                icon: "plus",
                onClick: e(h)
              }, {
                default: o(() => [
                  pl
                ]),
                _: 1
              }, 8, ["onClick"])), [
                [b, { Permissions: e(ee), access: [(fe = e(Z)) == null ? void 0 : fe.add] }]
              ]),
              e(L) ? de((c(), v(e(oe), {
                key: 0,
                disabled: e($).length <= 0,
                type: "danger",
                icon: "delete",
                onClick: e(P)
              }, {
                default: o(() => [
                  fl
                ]),
                _: 1
              }, 8, ["disabled", "onClick"])), [
                [b, { Permissions: e(ee), access: [(ye = e(Z)) == null ? void 0 : ye.remove] }]
              ]) : z("", !0),
              R(l.$slots, "button-left", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            G("div", _l, [
              R(l.$slots, "button-right", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            i(e(We), { style: { "flex-shrink": "0", width: "150px" } }, {
              default: o(() => [
                i(e(oe), {
                  color: "#67c23a",
                  icon: "search",
                  onClick: e(a)
                }, null, 8, ["onClick"]),
                i(e(oe), {
                  color: "#e6a23c",
                  icon: "refresh",
                  onClick: s[0] || (s[0] = (N) => e(F).SearchFormRef.resetFields())
                }),
                i(e(oe), {
                  color: "#409eff",
                  icon: "expand",
                  onClick: s[1] || (s[1] = (N) => y.value = !e(y))
                })
              ]),
              _: 1
            })
          ], 512),
          i(sl, {
            height: e(me),
            onRowContextmenu: O
          }, {
            "table-column": o(() => [
              R(l.$slots, "table-column", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            "menu-top": o((N) => [
              R(l.$slots, "menu-top", {
                scope: N,
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            "menu-bottom": o((N) => [
              R(l.$slots, "menu-bottom", {
                scope: N,
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            _: 3
          }, 8, ["height"]),
          G("div", {
            ref_key: "paginationDivRef",
            ref: g,
            style: { "padding-top": "20px" }
          }, [
            i(dl)
          ], 512),
          i(e(Qe), {
            class: "DialogVisible",
            modelValue: e(M),
            "onUpdate:modelValue": s[5] || (s[5] = (N) => Ie(M) ? M.value = N : null),
            title: e(E) === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: e(X),
            "close-on-press-escape": e(re),
            fullscreen: e(Y),
            "close-on-click-modal": e(j)
          }, ke({
            default: o(() => [
              i(rl, { height: e(A) }, {
                "edit-form": o(() => [
                  R(l.$slots, "edit-form", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                "edit-form-top": o(() => [
                  R(l.$slots, "edit-form-top", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                "edit-form-bottom": o(() => [
                  R(l.$slots, "edit-form-bottom", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["height"])
            ]),
            _: 2
          }, [
            e(r) ? {
              name: "footer",
              fn: o(() => [
                G("div", ml, [
                  R(l.$slots, "edit-form-footer", {}, void 0, !0),
                  i(e(oe), {
                    onClick: s[2] || (s[2] = (N) => M.value = !1)
                  }, {
                    default: o(() => [
                      bl
                    ]),
                    _: 1
                  }),
                  i(e(oe), {
                    type: "warning",
                    plain: "",
                    onClick: s[3] || (s[3] = (N) => e(F).EditFormRef.resetFields())
                  }, {
                    default: o(() => [
                      vl
                    ]),
                    _: 1
                  }),
                  i(e(oe), {
                    type: "primary",
                    loading: e(t),
                    onClick: s[4] || (s[4] = (N) => e(C)(e(F).EditFormRef))
                  }, {
                    default: o(() => [
                      gl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ])
      ], 512);
    };
  }
});
const we = /* @__PURE__ */ Re(hl, [["__scopeId", "data-v-1c478c0a"]]), Fl = {
  mounted(n, p, f) {
    const _ = p.value.Permissions, a = p.value.access;
    let h = !1;
    for (let C = 0; C < a.length; C++)
      _.includes(a[C]) && (h = !0);
    h || n.parentNode && n.parentNode.removeChild(n);
  }
};
we.install = (n) => {
  n.component("CrudEl", we), n.directive("Auth", Fl);
};
const Pl = (n, p) => {
  p ? (p.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), Ye(p), n.use(we)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  Pe as DataMerger,
  I as DeepClone,
  Ye as InitSys,
  Pl as createCrudEl,
  ae as hooksName,
  Ge as isObjEqual,
  Xe as useHooks
};
